#Include <Array.au3>


#cs

On my keyboard, the M, < and > are next to each other bottom right.  So I used
these three keys for selecting the tags and accepting it.  If you use the home
row, and you drop your hand one row, the < and > should be under your middle
and ring finger, and the M should be under your forefinger.  On the home row,
the K is under your middle finger.

Ctrl+< = previous tag
Ctrl+> = next tag
Ctrl+M = accept tag
Ctrl+K = accept tag

You can also accept the tag by pressing the left or right arrow, obviously, but
Ctrl+M (or Ctrl+K) will ensure that the cursor is directly after the tag and not one position
away from it.

If you use Ctrl <, >, M and K anywhere else, nothing will happen.

#ce

Global $foo
Global $tags
Global $words
Global $len
Global $ben
Global $numtags
Global $numwords
Global $j
Global $k
Global $a

HotKeySet("^m", "Cancel")
HotKeySet("^k", "Cancel")
HotKeySet("^.", "NextTag")
HotKeySet("^,", "PrevTag")
HotKeySet("^]", "NextWord")
HotKeySet("^[", "PrevWord")

$j = 0
$k = 0
$a = 1
$z = 1

$time1 = FileGetTime ("source.txt", 0, 1)
$fileopen = FileOpen ("source.txt", 128)
$foo = FileRead ("source.txt")
FileClose ("source.txt")
$tags = StringRegExp ($foo, '(<[/]{0,1}[a-z]{0,3}[0-9]{0,5}[/]{0,1}>)', 3)
$words = StringRegExp ($foo, '([A-Z]+[a-z]*)', 3)

$numtags = UBound($tags)
If @error = 1 Then
$tagsx = 0
Else
$tagsx = 1
EndIf
$numwords = UBound($words)
If @error = 1 Then
$wordsx = 0
Else
$wordsx = 1
EndIf


While 1
    Sleep(1000)

$time2 = FileGetTime ("source.txt", 0, 1)

If $time2 <> $time1 Then
$fileopen = FileOpen ("source.txt", 128)
$foo = FileRead ("source.txt")
FileClose ("source.txt")
$tags = StringRegExp ($foo, '(<[/]{0,1}[a-z]{0,3}[0-9]{0,5}[/]{0,1}>)', 3)
$words = StringRegExp ($foo, '([A-Z]+[a-z]*)', 3)

$numtags = UBound($tags)
If @error = 1 Then
$tagsx = 0
Else
$tagsx = 1
EndIf
$numwords = UBound($words)
If @error = 1 Then
$wordsx = 0
Else
$wordsx = 1
EndIf

$time1 = FileGetTime ("source.txt", 0, 1)
EndIf

WEnd

; ================================

Func NextTag ()

If $tagsx = 1 Then
If WinActive ("OmegaT", "") Then

If $j = $numtags - 1 Then
$j = 0
Else
$j = $j + 1
EndIf

ClipPut ($tags[$j])
$len = StringLen ($tags[$j])

Send ("^v")
Send ("{LEFT " & $len & "}")
Send ("+{RIGHT " & $len & "}")
Send ("{ESC}")
Send ("{ESC}")

EndIf
EndIf

EndFunc


Func PrevTag ()

If $tagsx = 1 Then
If WinActive ("OmegaT", "") Then

If $j = 0 Then
$j = $numtags - 1
Else
$j = $j - 1
EndIf

ClipPut ($tags[$j])
$len = StringLen ($tags[$j])

Send ("^v")
Send ("{LEFT " & $len & "}")
Send ("+{RIGHT " & $len & "}")
Send ("{ESC}")
Send ("{ESC}")

EndIf
EndIf

EndFunc

; =============================

Func Cancel ()

If WinActive ("OmegaT", "") Then

Send ("{LEFT}")
Send ("{RIGHT}")

EndIf

EndFunc

; ===============================


Func NextWord ()

If $wordsx = 1 Then
If WinActive ("OmegaT", "") Then

If $k = $numwords - 1 Then
$k = 0
Else
$k = $k + 1
EndIf

ClipPut ($words[$k])
$len = StringLen ($words[$k])

Send ("^v")
Send ("{LEFT " & $len & "}")
Send ("+{RIGHT " & $len & "}")
Send ("{ESC}")
Send ("{ESC}")

EndIf
EndIf

EndFunc


Func PrevWord ()

If $wordsx = 1 Then
If WinActive ("OmegaT", "") Then

If $k = 0 Then
$k = $numwords - 1
Else
$k = $k - 1
EndIf

ClipPut ($words[$k])
$len = StringLen ($words[$k])

Send ("^v")
Send ("{LEFT " & $len & "}")
Send ("+{RIGHT " & $len & "}")
Send ("{ESC}")
Send ("{ESC}")

EndIf
EndIf

EndFunc



